<?php
	// Persian Guestbook Script
	// Copyleft 2011, AMIB
	// amibct@gmail.com
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
	<meta http-equiv="content-type" content="text/html;charset=utf-8" />
	<meta http-equiv="content-script-type" content="text/javascript" />
	<meta http-equiv="content-language" content="fa-IR" />

	<meta name="description" content="دفتر یادبود امیب" />
	<meta name="keywords" content="دفتر یادبود امیب" />
	<title>دفتر یادبود امیب</title>
	
	<meta http-equiv="pragma" content="no-cache" />
	<meta http-equiv="cache-control" content="no-cache" />
	
	<link rel="stylesheet" type="text/css" href="style/guestbook.css" />
</head>

<body>
	<div id="bg">
		<div id="text">
<?php
$errors = array();
$private = isset( $_POST[ 'private' ] ) ? '1' : '';
$bSubmitted = isset( $_POST[ 'submitted' ] );

if ( $bSubmitted ) {

	$name = trim( $_POST[ 'name' ] );
	$email = trim( $_POST[ 'email' ] );
	$message = trim ( preg_replace( '/[\r\n]*[\s\t]*[\r\n]+/', "\n", $_POST[ 'message' ] ) ); // Remove empty lines and trailing spaces/tabs
	$website = trim( $_POST[ 'website' ] );

	if ( strlen( $name ) == 0 ) {
		$errors[] = 'نام خود را وارد نکرده‌اید.';
	} else if ( strlen( $name ) > 100 ) {
		$errors[] = 'بیشینه‌ی بلندی نام ۱۰۰ نویسه است.';
	}
	
	if ( strlen( $email ) > 100 ) {
		$errors[] = 'بیشینه‌ی بلندی رایانامه ۱۰۰ نویسه است.‌';
	} else if( !isValidEmail( $email ) ) {
		$errors[] = 'رایانامه را به درستی وارد نکرده‌اید.';
	}

	if ( strlen( $message ) == 0 ) {
		$errors[] = 'پیام خود را وارد نکرده‌اید.';
	} else if ( strlen( $message ) > 1024 ) {
		$errors[] = 'بیشینه‌ی بلندی پیام ۵۰۰ نویسه است.';
	}

	if ( strlen( $_POST[ 'captcha' ] ) == 0 ) {
		$errors[] = 'وارد کردن کد امنیتی الزامی است.';
	} else if ( $_SESSION[ 'session_captchaText'] != $_POST[ 'captcha' ] ) {
		$errors[] = 'کد امنیتی به درستی وارد نشده است.';
	}
}

$bErrors = ( count( $errors ) == 0 ? false : true );
	
?>
<h1 class="Title">پیام تازه</h1>
<div class="Border">
	<form action="#" method="post" onsubmit="document.getElementById('cmdSubmit').disabled = 1;">
		<table>
			<col id="labels" />
			<tr>
				<td><label for="name">نام</label></td>
				<td><input type="text" maxlength="30" name="name" id="name" value="<?php if ( $bErrors && isset( $name ) ) echo htmlspecialchars( $name ); ?>" /></td>
				<td rowspan="5">
					<div class="info">
						- این برگ برای دریافت پیشنهادها، انتقادها، و دیگر گفتارهای شما برپا شده است.<br />
						- پیام‌های دربرگیرنده‌ی آگهی، واژه‌های بی‌جا و ناپسند پاک خواهند شد.<br />
						- در نوشتن پیام‌های خود تلاش کنید از ادبیات زیبا بهره بگیرید.<br />
						- کدهای HTML در متن  پیام ناکارا هستند.<br />
						- رایانامه‌ی شما به صورت خصوصی نزد ما نگاه داشته می‌شود.<br />
						- IP شما به صورت خصوصی در پایگاه داده ذخیره می‌شود
					</div>
				</td>
			</tr>
			<tr>
				<td><label for="email">رایانامه( E-Mail )</label></td>
				<td><input type="text" maxlength="100" name="email" id="email" value="<?php if ( $bErrors && isset( $email ) ) echo htmlspecialchars( $email ); ?>" /></td>
			</tr>
			<tr>
				<td><label for="website">تارنما</label></td>
				<td><input type="text" maxlength="100" name="website" id="website" value="<?php if ( $bErrors && isset( $website ) ) echo htmlspecialchars( $website ); ?>" /></td>
			</tr>
			<tr>
				<td><label for="message">پیام</label></td>
				<td><textarea cols="20" rows="5" name="message" id="message"><?php if ( $bErrors && isset( $message ) ) echo htmlspecialchars( str_replace( array ( "\r\n", "\r", "\n" ) , '%#newline#', $message ) ); ?></textarea><br />
					<input type="checkbox" name="private" id="private" <?php if ( $bErrors && $private != '' ) echo 'checked="' . $private . '"';?> />پیام خصوصی برای سرپرست تارنما
				</td>
			</tr>
			<tr>
				<td><label for="captcha">کد امنیتی</label></td>
				<td>
					<img id="captimg" src="images/captcha.php?noCache=<?php echo uniqid( '' ); ?>.png" alt="-&gt; لطفا تصویر‌ها را فعال کنید" />
					<a id="reload" href="#" onclick="document.getElementById('captimg').src = 'images/captcha.php?' + Math.random(); document.getElementById('captcha').value = ''; return false;">جایگزین کردن کد</a><br />
					<input type="text" maxlength="5" name="captcha" id="captcha" value="" />
				</td>
			</tr>
			<tr>
				<td></td>
				<td id="subtd">
					<input type="hidden" name="submitted" value="true" />
					<input type="submit" value="فرستادن پیام" name="cmdSubmit" id="cmdSubmit" />
				</td>
			</tr>
		</table>
	</form>
	<?php
		if( $bSubmitted == true && $bErrors == true ) {
			echo "<div id='error'>\n";
			
			foreach( $errors as $error ) {
				echo "\t\t- " . $error . "<br />\n";
			}
			
			echo "\t</div>";
			
		} elseif ( $bSubmitted == true ) { //Everyting is OK; Save message;
			
			if ( file_exists ( 'guestbook.db' ) ) { 
				$db = sqlite_open( 'guestbook.db', 0666 );
				
				$name = sql_quote( $name );
				$email = sql_quote( $email );
				$message = sql_quote( $message );
				$website = sql_quote( $website );
				$iprivate = ( $private == '1' ? 1 : 0 );
				$IP = ip2long( get_real_ip() );
				$time = time();
				
				$sql = 	'SELECT * FROM Messages WHERE IP=' . $IP . ' AND Private = ' . $iprivate
					. ' AND Timestamp > ' . ( $time - 2 * 60 ); // At least 2 minutes between messages
					
				$query = sqlite_query( $db, $sql );
				
				if ( $entry = sqlite_fetch_array( $query, SQLITE_NUM ) ) {
					echo "<div id='error'>\n";
					echo "\tبرای فرستادن پیام جدید، کمینه باید ۲ دقیقه منتظر بمانید.";
					echo '</div>';
					
				} else {
					$sql = 	'INSERT INTO Messages( Sender, EMail, WebSite, Message, Private, IP, Timestamp ) VALUES '
							. "( '$name', '$email', '$website', '$message', $iprivate, $IP, $time )";
					
					$query = sqlite_query( $db, $sql );
					
					echo '<div class="info">' . "\n";
					echo "\tاز اینکه پیام" . ( $iprivate ? ' <b>خصوصی</b>': '' ). ' خود را فرستادید، سپاسگزارم' . "\n";
					echo '</div>';
				}
				sqlite_close( $db );
				
			}

		}
	?> 

</div>

<h1 class="Title">پیام‌های دیگران</h1>
<div class="Border">
	<ul>
<?php
	if ( file_exists ( 'guestbook.db' ) ) { 
		$db = sqlite_open('guestbook.db', 0666 );
		$query = sqlite_query($db, 'SELECT * FROM Messages WHERE Private = 0 ORDER BY Timestamp DESC');

		while ( $entry = sqlite_fetch_array( $query, SQLITE_ASSOC ) ) {
			$msg = nl2br( htmlspecialchars( $entry[ 'Message'] ) );
			$sender = htmlspecialchars( $entry[ 'Sender'] );
			$website = htmlspecialchars( $entry[ 'WebSite' ] );
			
			if ( preg_match( '/^(https?:\/\/)?[A-Z0-9]+\.[-A-Z0-9+&@#\/%?=~_|!,.;]*$/i', $website ) == 1 ) {
				
				if ( preg_match( '/^(https?:\/\/).*$/i', $website ) == 0 )
					$website = 'http://' . $website;
					
				echo "\t\t<li><span class='sender'><a href=\"$website\" title=\"تارنمای $sender\" rel=\"nofollow\">&#149; $sender</a>&rlm;</span> : $msg</li>\n";
			} else {
				echo "\t\t<li><span class='sender'>&#149; $sender&rlm;</span> : $msg</li>\n";
			}
		}
		
		sqlite_close( $db );
	} 
?>
	</ul>
</div>
<?php

function isValidEmail( $email ) { return eregi( "^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$", $email ); }

function sql_quote( $value ) {
	if( get_magic_quotes_gpc() )
		$value = stripslashes( $value );

//	if( function_exists( 'mysql_real_escape_string' ) ) {
//		$value = mysql_real_escape_string( $value );
//	} else {
		$value = addslashes( $value );
//	}
	
	return $value;
}

function get_real_ip() {

	if (isset( $_SERVER[ 'HTTP_CLIENT_IP' ] ) ) {
		return $_SERVER[ 'HTTP_CLIENT_IP' ];
	} elseif ( isset( $_SERVER[ 'HTTP_X_FORWARDED_FOR' ] ) ) {
		return $_SERVER[ 'HTTP_X_FORWARDED_FOR' ];
	} elseif ( isset( $_SERVER[ 'HTTP_X_FORWARDED' ] ) ) {
		return $_SERVER[ 'HTTP_X_FORWARDED' ];
	} elseif ( isset( $_SERVER[ 'HTTP_FORWARDED_FOR' ] ) ) {
		return $_SERVER[ 'HTTP_FORWARDED_FOR' ];
	} elseif ( isset( $_SERVER[ 'HTTP_FORWARDED' ] ) ) {
		return $_SERVER[ 'HTTP_FORWARDED' ];
	} else {
		return $_SERVER[ 'REMOTE_ADDR' ];
	}

}
?>
		</div>
	</div>
</body>

</html>